/*
 * This file is part of libdom.
 * Licensed under the MIT License,
 *                http://www.opensource.org/licenses/mit-license.php
 * Copyright 2012 Daniel Silverstone <dsilvers@netsurf-browser.org>
 */

/* Note, this file deliberately lacks guards since it's included many times
 * in many places in order to correctly handle the loading of the strings.
 */

#ifndef HTML_DOCUMENT_STRINGS_ACTION
#define HTML_DOCUMENT_STRINGS_INTERNAL_ACTION 1
#define HTML_DOCUMENT_STRINGS_PREFIX      \
	typedef enum {
#define HTML_DOCUMENT_STRINGS_SUFFIX		\
	hds_COUNT				\
	} html_document_memo_string_e;
#define HTML_DOCUMENT_STRINGS_ACTION(tag)	\
	hds_##tag,
#endif

#ifdef HTML_DOCUMENT_STRINGS_PREFIX
HTML_DOCUMENT_STRINGS_PREFIX
#endif

/* Useful attributes for HTMLElement */
HTML_DOCUMENT_STRINGS_ACTION(id)
HTML_DOCUMENT_STRINGS_ACTION(title)
HTML_DOCUMENT_STRINGS_ACTION(lang)
HTML_DOCUMENT_STRINGS_ACTION(dir)
HTML_DOCUMENT_STRINGS_ACTION(class)
/* Useful attributes used by HTMLHtmlElement */
HTML_DOCUMENT_STRINGS_ACTION(version)
/* Names for elements which get specialised. */
HTML_DOCUMENT_STRINGS_ACTION(HTML)
HTML_DOCUMENT_STRINGS_ACTION(HEAD)
HTML_DOCUMENT_STRINGS_ACTION(LINK)
HTML_DOCUMENT_STRINGS_ACTION(TITLE)
HTML_DOCUMENT_STRINGS_ACTION(META)
HTML_DOCUMENT_STRINGS_ACTION(BASE)
HTML_DOCUMENT_STRINGS_ACTION(ISINDEX)
HTML_DOCUMENT_STRINGS_ACTION(STYLE)
HTML_DOCUMENT_STRINGS_ACTION(BODY)
HTML_DOCUMENT_STRINGS_ACTION(FORM)
HTML_DOCUMENT_STRINGS_ACTION(SELECT)
HTML_DOCUMENT_STRINGS_ACTION(OPTGROUP)
HTML_DOCUMENT_STRINGS_ACTION(OPTION)
HTML_DOCUMENT_STRINGS_ACTION(INPUT)
HTML_DOCUMENT_STRINGS_ACTION(TEXTAREA)
HTML_DOCUMENT_STRINGS_ACTION(BUTTON)
HTML_DOCUMENT_STRINGS_ACTION(LABEL)
HTML_DOCUMENT_STRINGS_ACTION(FIELDSET)
HTML_DOCUMENT_STRINGS_ACTION(LEGEND)
HTML_DOCUMENT_STRINGS_ACTION(UL)
HTML_DOCUMENT_STRINGS_ACTION(OL)
HTML_DOCUMENT_STRINGS_ACTION(DL)
HTML_DOCUMENT_STRINGS_ACTION(DIR)
HTML_DOCUMENT_STRINGS_ACTION(MENU)
HTML_DOCUMENT_STRINGS_ACTION(LI)
HTML_DOCUMENT_STRINGS_ACTION(BLOCKQUOTE)
HTML_DOCUMENT_STRINGS_ACTION(DIV)
HTML_DOCUMENT_STRINGS_ACTION(P)
HTML_DOCUMENT_STRINGS_ACTION(H1)
HTML_DOCUMENT_STRINGS_ACTION(H2)
HTML_DOCUMENT_STRINGS_ACTION(H3)
HTML_DOCUMENT_STRINGS_ACTION(H4)
HTML_DOCUMENT_STRINGS_ACTION(H5)
HTML_DOCUMENT_STRINGS_ACTION(H6)
HTML_DOCUMENT_STRINGS_ACTION(Q)
HTML_DOCUMENT_STRINGS_ACTION(PRE)
HTML_DOCUMENT_STRINGS_ACTION(BR)
HTML_DOCUMENT_STRINGS_ACTION(BASEFONT)
HTML_DOCUMENT_STRINGS_ACTION(FONT)
HTML_DOCUMENT_STRINGS_ACTION(HR)
HTML_DOCUMENT_STRINGS_ACTION(INS)
HTML_DOCUMENT_STRINGS_ACTION(DEL)
HTML_DOCUMENT_STRINGS_ACTION(A)
HTML_DOCUMENT_STRINGS_ACTION(IMG)
HTML_DOCUMENT_STRINGS_ACTION(OBJECT)
HTML_DOCUMENT_STRINGS_ACTION(PARAM)
HTML_DOCUMENT_STRINGS_ACTION(APPLET)
HTML_DOCUMENT_STRINGS_ACTION(MAP)
HTML_DOCUMENT_STRINGS_ACTION(AREA)
HTML_DOCUMENT_STRINGS_ACTION(SCRIPT)
HTML_DOCUMENT_STRINGS_ACTION(TABLE)
HTML_DOCUMENT_STRINGS_ACTION(CAPTION)
HTML_DOCUMENT_STRINGS_ACTION(COL)
HTML_DOCUMENT_STRINGS_ACTION(COLGROUP)
HTML_DOCUMENT_STRINGS_ACTION(THEAD)
HTML_DOCUMENT_STRINGS_ACTION(TFOOT)
HTML_DOCUMENT_STRINGS_ACTION(TBODY)
HTML_DOCUMENT_STRINGS_ACTION(TR)
HTML_DOCUMENT_STRINGS_ACTION(TH)
HTML_DOCUMENT_STRINGS_ACTION(TD)
HTML_DOCUMENT_STRINGS_ACTION(FRAMESET)
HTML_DOCUMENT_STRINGS_ACTION(FRAME)
HTML_DOCUMENT_STRINGS_ACTION(IFRAME)

#ifdef HTML_DOCUMENT_STRINGS_SUFFIX
HTML_DOCUMENT_STRINGS_SUFFIX
#endif


#ifdef HTML_DOCUMENT_STRINGS_INTERNAL_ACTION
#undef HTML_DOCUMENT_STRINGS_INTERNAL_ACTION
#undef HTML_DOCUMENT_STRINGS_PREFIX
#undef HTML_DOCUMENT_STRINGS_SUFFIX
#undef HTML_DOCUMENT_STRINGS_ACTION
#endif
